<?php
//
//	Module name      :	debug.php
//	Version          :	1.0
//	Started on       :	April 27, 2005
//	Completed on     :	April 27, 2005
//
//	Module type      :	Library
//	Description      :	Utilities for debugging
//
//	Developed under  :	Php 4.1.2
//	Sw requirements  :	None
//
//	Parameters       :	None
//	Notes - usage    :	None
//


//--- Include files --------------------------------------------------------------------------------



//--- Public constants -----------------------------------------------------------------------------



define("D_MODULE_NAME", "debug.php 1.0; on April 27, 2005 by J.Hubb.");

// Default values for Debug window position
define("D_WIN_DEF_X",		0);
define("D_WIN_DEF_Y",		0);
define("D_WIN_DEF_WIDTH",	300);
define("D_WIN_DEF_HEIGHT",	480);
define("D_WIN_DEF_RECLEAR",	TRUE);

// Number of microseconds timers
define("D_MTIMER_NUM",	10);

// Error codes
define("D_NO_ERROR",	0);
define("D_LAST_ERROR",	0);



//--- Public variables -----------------------------------------------------------------------------



//--- Private constants ----------------------------------------------------------------------------



//--- Private variables ----------------------------------------------------------------------------



$_D_win_x = D_WIN_DEF_X;
$_D_win_y = D_WIN_DEF_Y;
$_D_win_width = D_WIN_DEF_WIDTH;
$_D_win_height = D_WIN_DEF_HEIGHT;
$_D_win_reclear = D_WIN_DEF_RECLEAR;

$_D_win_call_num = 1;

$_D_mtimer = array();		// Microtimer timestamps;

$_D_error_num = D_NO_ERROR;
$_D_error_msg = array(
	D_NO_ERROR	=> "No error"
	);



//--- Public functions code ------------------------------------------------------------------------



function DErrorMsg()
// Returns the error message of the last module function called.
{
	global $_D_error_msg, $_D_error_num;

	return $_D_error_msg[$_D_error_num];
}



function DCloseDebugWindow()
// Closes the Debug window. Returns nothing.
{
	global $_D_win_call_num;

	print "
			<script language='javascript'>
				d_win.close();
			</script>
    	";
    $_D_win_call_num = 1;
}



function DMtimerReset($n = 0)
// Resets the microsecond timer named $n.
{
	global $_D_mtimer;

	$_D_mtimer[$n] = microtime();
}



function DMtimerRead($n = 0)
// Returns elapsed seconds (with microsecond resolution) since the reset of microsecond timer named $n.
// If $n does not exist, it returns -1.
{
	global $_D_mtimer;

	$now = microtime();
	$t1 = explode(" ", $now);
	if (array_key_exists($n, $_D_mtimer))
		$t0 = explode(" ", $_D_mtimer[$n]);
	else
	{
		$t0 = $t1;
		$t0[1] += 1;	// Generate a negative value.
	}
	return number_format($t1[1] - $t0[1] + $t1[0] - $t0[0], 6);
}



function DPrint()
// Prints all parameters passed. Returns the value of the last parameter.
{
	static $call_num = 1;

	print "
		<table border=2 cellspacing=0 cellpadding=3 width=100%>
			<tr valign=top>
				<td rowspan=" . func_num_args() . " width=1%>
					<center><font color=" . ($call_num == 1 ? "FF" : "00") . "0000><b>DPrint<br>Call&nbsp;$call_num</b></font></center>
				</td>
		";
	for ($i = 0; $i < func_num_args(); $i++)
	{
		$result = func_get_arg($i);
		print "<td><pre>";
		print_r($result);
		print "</pre></td></tr><tr>";
	}
	print "</tr></table>";
	$call_num++;
	return @$result;
}



function DResult()
// Returns the error code of the last module function called.
{
	global $_D_error_num;

	return $_D_error_num;
}



function DSetDebugWindow($x = D_WIN_DEF_X, $y = D_WIN_DEF_Y,
						 $width = D_WIN_DEF_WIDTH, $height = D_WIN_DEF_HEIGHT, $reclear = D_WIN_DEF_RECLEAR)
// Sets for Debug window the position $x, $y, dimensions $width, $height, its reclear property. Return
// nothing.
{
	global $_D_win_x, $_D_win_y, $_D_win_width, $_D_win_height, $_D_win_reclear;

	$_D_win_x = $x;
	$_D_win_y = $y;
	$_D_win_width = $width;
	$_D_win_height = $height;
	$_D_win_reclear = $reclear;
}



function DShow()
// Prints all parameters passed in a secondary window with title "DebugWin". Returns the value of the last
// parameter.
{
	global $_D_win_x, $_D_win_y, $_D_win_width, $_D_win_height, $_D_win_reclear;
	global $_D_win_call_num;

	if ($_D_win_call_num == 1)
		print "
			<script language='javascript'>
				d_win = window.open('', 'DebugWin',
						'left=$_D_win_x,top=$_D_win_y,width=$_D_win_width,height=$_D_win_height,\\
						titlebar=no,menubar=no,toolbar=no,directories=no,resizable=yes,scrollbars=yes');
				<!-- Do not use spaces in the above row or Netscape will not work...! -->
				" . ($_D_win_reclear ? "d_win.document.close();" : "") . "
				d_win.document.writeln('<head><title>Debug Window</title></head>');
			</script>
			";
	print "
			<script language='javascript'>
				d_win.document.writeln('<table border=2 cellspacing=0 cellpadding=3 width=100%>');
				d_win.document.writeln('	<tr valign=top>');
				d_win.document.writeln('		<td rowspan=" . func_num_args() . " width=1%>');
				d_win.document.writeln('			<center><font color=" . ($_D_win_call_num == 1 ? "FF" : "00") . "0000><b>DShow<br>Call&nbsp;$_D_win_call_num</b></font></center>');
				d_win.document.writeln('		</td>');
    	";
	for ($i = 0; $i < func_num_args(); $i++)
	{
		print "
				d_win.document.writeln('		<td>');
			";
		ob_start("_DPrintRCallBack");
		$result = func_get_arg($i);
		print_r($result);
		ob_end_flush();
		print "
				d_win.document.writeln('		</td>');
				d_win.document.writeln('	</tr><tr>');
			";
	}
	print "
				d_win.document.writeln('	</tr>');
				d_win.document.writeln('</table>');
		</script>
		";
	$_D_win_call_num++;
	return @$result;
}



//--- Private functions code -----------------------------------------------------------------------



function _DPrintRCallBack($buffer)
// Callback function for DShow(). Returns a JavaScript formatted string for print_r(). Unuseful if called
// directly.
{
	$buffer2 = str_replace("\n", "\\n\\\n", addslashes(rtrim($buffer)));
	return "	d_win.document.write('<pre>$buffer2</pre>');";
}



//--- Initialization code --------------------------------------------------------------------------



?>
